01揹包 HDU - 2955 小偷搶銀行


The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.




For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output

2
4
6


#include <iostream>
#include  <algorithm>
#include <cstring>
using namespace std;
int t,n;
double p;
double dp[10005];
int money[105];
double pro[105];
int main()
{
	cin>>t;
	while(t--)
	{
		int sum=0;
		cin>>p>>n;
		for(int i=1;i<=n;i++)
		{
			double d;
			cin>> money[i]>>pro[i];
			sum+= money[i];
		}
		 memset(dp,0,sizeof(dp));
		 dp[0]=1;  //dp裏面爲不被抓的概率  這樣表示什麼都不拿 那麼不被抓的概率一定爲1

		for(int i=1;i<=n;i++)
		for(int j=sum;j>= money[i];j--)
		{
			dp[j]=max(dp[j],dp[j- money[i]]*(1-pro[i])); //找最大的不被抓的概率
		}

		for(int i=sum;i>=0;i--)
		{
			if(dp[i]>=(1-p))  {
				cout<<i<<endl;
				break;
			}
		}

	}
}


/*題意:
給N個銀行,給出每個銀行裏相應的錢數money[i]和搶這個銀行被抓的概率pro[i]。
問在不被抓的情況下(被抓的概率小於給定值p時安全)能搶得的最大錢數。*/

/*思路:
1、搶n個銀行,不被抓,是每次都不被抓,用乘法原理處理每次不被抓的概率。
2、轉化爲0 1 揹包:將所有銀行的總錢數當做揹包的容積v,將不被抓的概率當做價值,
       在一般的0 1揹包中都是加上價值 ,這裏由於是乘法原理,所以應該是轉化爲乘法。
       這樣,傳統的01揹包累加問題變成了壘乘。
3、狀態轉移方程:dp[j]=max(dp[j],dp[j- money[i]]*(1-pro[i]))
     dp[j]表示搶j錢時的最大不被抓概率。*/


發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章